{-----------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/MPL-1.1.html

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: main.PAS, released on 3 April 2005.

The Initial Developer of the Original Code is Alexey Nikitayev [nikitayev@rsu.ru]
All Rights Reserved.

Contributor(s):

Last Modified: 4 April 2005

You may retrieve the latest version of this file at the Project Opencomputer's home page,
located at http://opencomputer.narod.ru/

Known Issues:

Used components:
  Imaging Toolkit for Delphi, Version 1.6
  www.mcm-design.com
  http://delphi.icm.edu.pl/ftp/d70share/dp7img.zip

-----------------------------------------------------------------------------}
unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, mcmImage, mcmImageFile, mcmThumbnail, ExtCtrls, StdCtrls,
  FileCtrl, ComCtrls, ShellCtrls, mcmImageKernel, mcmImageMath,
  mcmImageTransform;

type
  TRGB = record
    b,g,r:byte;
  end;
  pRGB = ^TRGB;

type
  TForm1 = class(TForm)
    Button1: TButton;
    ScrollBox2: TScrollBox;
    mcmImageCtrl1: TmcmImageCtrl;
    ShellListView1: TShellListView;
    ShellTreeView1: TShellTreeView;
    ProgressBar1: TProgressBar;
    Label1: TLabel;
    Label2: TLabel;
    procedure mcmThumbView1LoadImage(Sender: TObject; Filename: String);
    procedure Button1Click(Sender: TObject);
    procedure ShellListView1MouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure ShellListView1AddFolder(Sender: TObject;
      AFolder: TShellFolder; var CanAdd: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
    function LoadImage (const Filename:string):HBITMAP;
    function Convert (const Filename:string):boolean;
    procedure RGBAligment (Image:TmcmImage);
    procedure AutoLevels (Image:TmcmImage);
  end;

var
  Form1: TForm1;

implementation
uses mcmImageTypeDef,math;

{$R *.dfm}

procedure TForm1.ShellListView1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  LI:TListItem;
  tmp:TShellFolder;
  s1:string;
begin
  LI:=ShellListView1.GetItemAt(X,Y);
  if (LI=nil) then exit;
  tmp:=ShellListView1.Folders[LI.Index];
  if (tmp.IsFolder) then exit;
  s1:=tmp.PathName;
  if (s1<>'') then
  begin
    mcmThumbView1LoadImage(self,s1);
    AutoLevels(mcmImageCtrl1.Image);
  end;
end;

procedure TForm1.ShellListView1AddFolder(Sender: TObject;
  AFolder: TShellFolder; var CanAdd: Boolean);
var
  ext:string[31];
begin
  if (AFolder.IsFolder) then
  begin
    CanAdd:=true;
    exit;
  end;
  CanAdd:=false;
  ext:=ExtractFileExt(AFolder.DisplayName);
  if (ext='') or (ext='.') then exit;
  ext:=UpperCase(ext);
  delete(ext,1,1);
  if (ext='JPG') or (ext='JPEG') then CanAdd:=true else
  if (ext='GIF') then CanAdd:=true else
  if (ext='TIF') then CanAdd:=true else
  if (ext='TGA') then CanAdd:=true else
  if (ext='PNG') then CanAdd:=true else
  if (ext='BMP') then CanAdd:=true else
  if (ext='PCX') then CanAdd:=true else
  if (ext='KDC') then CanAdd:=true else
  if (ext='DIB') then CanAdd:=true;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  i,Count:Integer;
  SelectedItem, SelectedCount:Integer;
  FileName:string;
begin
  if (ShellListView1.SelCount=0) then exit;
  ForceDirectories(ShellTreeView1.Path+'\email');
  Button1.Enabled:=false;
  Screen.Cursor:=crHourGlass;
  Count:=ShellListView1.Items.Count;
  SelectedItem:=0;
  SelectedCount:=ShellListView1.SelCount;
  for i:=0 to Count-1 do
  begin
    if (ShellListView1.Items[i].Selected) then
    begin
      FileName:=ShellListView1.Folders[i].PathName;
      if Convert(FileName) then
      begin
        ShellListView1.Items[i].Selected:=false;
      end;
      FileName:='';
      Inc(SelectedItem);
    end;
    ProgressBar1.Position:=round(100.000*SelectedItem/SelectedCount);
    Application.ProcessMessages;
  end;
  Button1.Enabled:=true;
  Screen.Cursor:=crDefault;
  ProgressBar1.Position:=0;
  ShellListView1.Refresh;
end;

function TForm1.LoadImage(const Filename: string): HBITMAP;
var
  ext:string[5];
  FFormat:TmcmFileFormat;
begin
  ext:=ExtractFileExt(FileName);
  ext:=UpperCase(ext);
  delete(ext,1,1);
  FFormat:=FF_JPEG;
  if (ext='JPG') or (ext='JPEG') then FFormat:=FF_JPEG else
  if (ext='GIF') then FFormat:=FF_GIF else
  if (ext='TIF') then FFormat:=FF_TIFF else
  if (ext='TGA') then FFormat:=FF_TARGA else
  if (ext='PNG') then FFormat:=FF_PNG else
  if (ext='BMP') then FFormat:=FF_BMP else
  if (ext='PCX') then FFormat:=FF_PCX else
  if (ext='KDC') then FFormat:=FF_KDC else
  if (ext='DIB') then FFormat:=FF_DIB;
  try
    result:=ImageFileManager.LoadImage(Filename,FFormat);
  except
    result:=0;
  end;
end;

function TForm1.Convert(const Filename: string): boolean;
const setmaxdim=1024;
var
  //JPEGStream:TMemoryStream;
  MaxDim:Integer;
  FImage1,FImage2  : TmcmImage;
  mcmImageTransform: TmcmImageTransform;
  function NewFileName:string;
  var
    fileextsize:Integer;
    exfilename:string;
  begin
    exfilename:=ExtractFileName(FileName);
    fileextsize:=Length(ExtractFileExt(exfilename));
    result:=ExtractFilePath(FileName)+'\email\'+copy(exfilename,1,Length(exfilename)-fileextsize)+'.jpg';
  end;
begin
  result:=false;

  FImage1:=TmcmImage.Create;
  FImage1.DibHandle:=LoadImage(Filename);
  if (FImage1.DibHandle=0) then exit;
  
  try
    MaxDim:=max(FImage1.Width,FImage1.Height);
    ImageFileManager.Compression := CP_JPEG_STD;
    ImageFileManager.Quality:=80;
    if (MaxDim>setmaxdim) then
    begin
      FImage2:=TmcmImage.Create;
      mcmImageTransform:=TmcmImageTransform.Create(nil);
      mcmImageTransform.SourceImage[0]:=FImage1;
      mcmImageTransform.ResultImage:=FImage2;
      if (FImage1.Width>=FImage1.Height) then
      begin
        FImage2.Width:=setmaxdim;
        FImage2.Height:=round(FImage1.Height*setmaxdim/FImage1.Width);
      end else
      begin
        FImage2.Width:=round(FImage1.Width*setmaxdim/FImage1.Height);
        FImage2.Height:=setmaxdim;
      end;
      mcmImageTransform.Resize(ST_BICUBIC);
      FreeAndNil(mcmImageTransform);
      AutoLevels(FImage2);
      ImageFileManager.SaveImage(NewFileName,FF_JPEG,FImage2.DibHandle);
      FreeAndNil(FImage2);
    end else
    begin
      AutoLevels(FImage1);
      ImageFileManager.SaveImage(NewFileName,FF_JPEG,FImage1.DibHandle);
    end;
  finally
    FreeAndNil(FImage1);
  end;
end;

procedure TForm1.mcmThumbView1LoadImage(Sender: TObject;Filename: String);
begin
  Screen.Cursor:=crHourGlass;
  ShellListView1.Enabled:=false;
  mcmImageCtrl1.Image.DibHandle:=LoadImage(Filename);
  if (mcmImageCtrl1.Image.DibHandle<>0) then
  begin
    mcmImageCtrl1.Width:=mcmImageCtrl1.Image.Width;
    mcmImageCtrl1.Height:=mcmImageCtrl1.Image.Height;
  end;
  ShellListView1.Enabled:=true;
  Screen.Cursor:=crDefault;
end;

procedure TForm1.RGBAligment(Image: TmcmImage);
var
  i:Integer;
  DIB:pRGB;
  rsum,gsum,bsum,pixelcount:Integer;
  rkoeff,gkoeff,bkoeff,maxkoeff:double;
begin
  rsum:=0;
  gsum:=0;
  bsum:=0;
  pixelcount:=Image.Width*Image.Height;
  if (pixelcount=0) then exit;

  DIB:=Image.pDib;
  if (DIB=nil) then exit;
  if (Image.BitCount<>24) then exit;
  for i:=0 to pixelcount-1 do
  begin
    Inc(bsum,DIB.b);
    Inc(gsum,DIB.g);
    Inc(rsum,DIB.r);
    Inc(DIB);
  end;

  bkoeff:=bsum/pixelcount;
  gkoeff:=gsum/pixelcount;
  rkoeff:=rsum/pixelcount;
  maxkoeff:=max(bkoeff,max(gkoeff,rkoeff));
  bkoeff:=maxkoeff/bkoeff;
  gkoeff:=maxkoeff/gkoeff;
  rkoeff:=maxkoeff/rkoeff;

  DIB:=Image.pDib;
  for i:=0 to pixelcount-1 do
  begin
    DIB.b:=min(round(DIB.b*bkoeff),255);
    DIB.g:=min(round(DIB.g*gkoeff),255);
    DIB.r:=min(round(DIB.r*rkoeff),255);
    Inc(DIB);
  end;
end;

procedure TForm1.AutoLevels(Image: TmcmImage);
var
  i:Integer;
  DIB:pRGB;
  rmin,rmax:byte;
  gmin,gmax:byte;
  bmin,bmax:byte;
  pixelcount:Integer;
  rkoeff,gkoeff,bkoeff:double;
begin
  rmin:=255;
  rmax:=0;
  gmin:=255;
  gmax:=0;
  bmin:=255;
  bmax:=0;
  pixelcount:=Image.Width*Image.Height;
  if (pixelcount=0) then exit;

  DIB:=Image.pDib;
  if (DIB=nil) then exit;
  if (Image.BitCount<>24) then exit;
  for i:=0 to pixelcount-1 do
  begin
    if (bmin>DIB.b) then bmin:=DIB.b else if (bmax<DIB.b) then bmax:=DIB.b;
    if (gmin>DIB.g) then gmin:=DIB.g else if (gmax<DIB.g) then gmax:=DIB.g;
    if (rmin>DIB.r) then rmin:=DIB.r else if (rmax<DIB.r) then rmax:=DIB.r;
    Inc(DIB);
  end;

  bkoeff:=255.000/(bmax-bmin);
  gkoeff:=255.000/(gmax-gmin);
  rkoeff:=255.000/(rmax-rmin);

  DIB:=Image.pDib;
  for i:=0 to pixelcount-1 do
  begin
    DIB.b:=round((DIB.b-bmin)*bkoeff);
    DIB.g:=round((DIB.g-gmin)*gkoeff);
    DIB.r:=round((DIB.r-rmin)*rkoeff);
    Inc(DIB);
  end;
end;

end.
